
// SetResDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SetRes.h"
#include "SetResDlg.h"
#include "videomod.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSetResDlg dialog




CSetResDlg::CSetResDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSetResDlg::IDD, pParent)
	, m_szCurrent(_T(""))
	, m_nResolution(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSetResDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_STATIC_CURRENT, m_szCurrent);
	DDX_Radio(pDX, IDC_RADIO1, m_nResolution);
}

BEGIN_MESSAGE_MAP(CSetResDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CSetResDlg message handlers

BOOL CSetResDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// set current indicator
	// width
	INT cx = GetSystemMetrics( SM_CXSCREEN );
	// height
	INT cy = GetSystemMetrics( SM_CYSCREEN );
	// format string
	m_szCurrent.Format( _T("Current Resolution: %d X %d"), cy, cx );
	// update data
	UpdateData( FALSE );

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSetResDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSetResDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CSetResDlg::OnOK()
{
	// update data
	UpdateData();

	BOOL bOk = FALSE;
	CVideoMode vMode;

	// get current
	CVideoModes::GetCurrentVideoMode( vMode );

	// set resolution
	switch( m_nResolution )
	{
	case 0:
		vMode.m_dwWidth = 800;
		vMode.m_dwHeight = 600;
		break;
	case 1:
		vMode.m_dwWidth = 1024;
		vMode.m_dwHeight = 768;
		break;
	}

	// change resolution
    LONG lError = CVideoModes::ChangeVideoModeTemporarily( vMode);
    switch (lError)
    {
      case DISP_CHANGE_SUCCESSFUL: /* Don't bother displaying a message box if successful */
		  bOk = TRUE;
		  break;
      case DISP_CHANGE_RESTART:
		  AfxMessageBox( _T("The computer must be restarted in order for this graphics mode to work"), MB_OK | MB_ICONEXCLAMATION );
		  break;
      case DISP_CHANGE_BADFLAGS:
		  AfxMessageBox( _T("An invalid set of flags was passed in"), MB_OK | MB_ICONEXCLAMATION );
		  break;
      case DISP_CHANGE_FAILED:
		  AfxMessageBox( _T("The display driver failed the specified graphics mode"), MB_OK | MB_ICONEXCLAMATION );
		  break;
      case DISP_CHANGE_BADMODE:
		  AfxMessageBox( _T("The graphics mode is not supported"), MB_OK | MB_ICONEXCLAMATION );
		  break;
      case DISP_CHANGE_NOTUPDATED:
		  AfxMessageBox( _T("Unable to write settings to the registry"), MB_OK | MB_ICONEXCLAMATION );
		  break;
      default:
		  AfxMessageBox( _T("Unexpected error value"), MB_OK | MB_ICONEXCLAMATION );
		  break;
    }
	// close dialog
	if( bOk )
		CDialog::OnOK();
}
